/**
 *
 * Editor WYSIWYG v1.0 RC3
 *
 * Este script convertira todos tus textareas en
 * editores WYSIWYG (What You See Is What You Get)
 * Un editor WYSIWYG permite al usuario escribir
 * textos con estilos de una manera practica y sencilla.
 * Funciona tanto en IE como en FireFox
 *
 * Este script ha sido desarrollado integramente
 * por Iván Arias (arias@elleondeoro.com), con modificaciones específicas para la Herramienta el Espía realizadas por Iván Gutiérrez.
 *
 */

var isIE = navigator.userAgent.toLowerCase().indexOf('msie') >= 0;
var isGECKO = navigator.userAgent.toLowerCase().indexOf('gecko') >= 0;

var textarea = null;
var config = { border: "1px solid #CCC", bgcolor: "#FFFFFF" };
var timers = new Array();

function strip_tags (input, allowed) {
    // Strips HTML and PHP tags from a string  
    // 
    // version: 1109.2015
    // discuss at: http://phpjs.org/functions/strip_tags    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Luke Godfrey
    // +      input by: Pul
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   bugfixed by: Onno Marsman    // +      input by: Alex
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: Marc Palau
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: Brett Zamir (http://brett-zamir.me)    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   bugfixed by: Eric Nagel
    // +      input by: Bobby Drake
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   bugfixed by: Tomasz Wesolowski    // +      input by: Evertjan Garretsen
    // +    revised by: Rafał Kukawski (http://blog.kukawski.pl/)
    // *     example 1: strip_tags('<p>Kevin</p> <b>van</b> <i>Zonneveld</i>', '<i><b>');
    // *     returns 1: 'Kevin <b>van</b> <i>Zonneveld</i>'
    // *     example 2: strip_tags('<p>Kevin <img src="someimage.png" onmouseover="someFunction()">van <i>Zonneveld</i></p>', '<p>');    // *     returns 2: '<p>Kevin van Zonneveld</p>'
    // *     example 3: strip_tags("<a href='http://kevin.vanzonneveld.net'>Kevin van Zonneveld</a>", "<a>");
    // *     returns 3: '<a href='http://kevin.vanzonneveld.net'>Kevin van Zonneveld</a>'
    // *     example 4: strip_tags('1 < 5 5 > 1');
    // *     returns 4: '1 < 5 5 > 1'    // *     example 5: strip_tags('1 <br/> 1');
    // *     returns 5: '1  1'
    // *     example 6: strip_tags('1 <br/> 1', '<br>');
    // *     returns 6: '1  1'
    // *     example 7: strip_tags('1 <br/> 1', '<br><br/>');    // *     returns 7: '1 <br/> 1'
	var result ="";
	if (input.charAt(input.length-1)=='>'){
		for (var x = 0;x<=(input.length-5);x++){
			result = result + input.charAt(x);
		}	
	}else{
	    result = input;
	}	
    allowed = (((allowed || "") + "").toLowerCase().match("") || []).join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
    //var tags =/<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
    //var tags = /<[^>]*>/gi,
	var tags = new RegExp('<[^>]*>', 'gi');
	var saltos = new RegExp('<br>', 'gi');
	var fontRaro = new RegExp('</f', 'gi');
	var spanRaro = new RegExp('</s', 'gi');
        var espacios = new RegExp('&nbsp;', 'gi');
	//var tags = /gi,
	    //commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/g,
    //    espacios = /&nbsp\;/gi, //Reemplazar espacios &nbsp; por ' '
    //    saltos = /<br>/gi, //Reemplazar saltos de línea <br> por su código correspondiente.
	//	font = /<\/f/gi, //Eliminar etiquetas font
	//	span = /<\/s/gi; //Eliminar etiquetas span
    //return result.replace(font, '').replace(tags, '').replace(espacios, ' ').replace(saltos, String.fromCharCode(10));
	//alert(result);
	result = result.replace(saltos, String.fromCharCode(10));
	result = result.replace(tags, '');
	result = result.replace(fontRaro, '');
	result = result.replace(spanRaro, '');
	result = result.replace(espacios, ' ');

	if ((result.charCodeAt(result.length-1)==10) && (estiloActivado==true)){
	   var aux = "";
	   for (var i=0;i<result.length-1;i++){
			aux=aux+result[i];	
		}
		result = aux;
	}
	//alert(result);
	return result;
	//return result.replace(tags, '');
}


function resetForm(event) {
  var source = getEventSource(event);
  var textareas = source.getElementsByTagName('textarea'); //Especificar el area de texto que deseamos como editor html
  var iframe;
  for (var i=0; i<textareas.length; i++) {
    iframe = document.getElementById(textareas[i].id+"_edit");
    if (iframe)
      getDocument(iframe).body.innerHTML = textareas[i].startContent;
  }
}


function addEvent(object, event, handler) {
 if (isIE)
    object.attachEvent("on" + event, handler);
  else
    object.addEventListener(event, handler, false)
}

function getDocument(iframe) {
  return isIE? document.frames[iframe.id].window.document : iframe.contentDocument;
}
function setTextareaContent(event, element) {
  var source = document.getElementById(element ? element : getEventSource(event).ownerDocument.editor);
  var target = document.getElementById(source.id.substring(0, source.id.indexOf("_")));
  //target.value = getDocument(source).innerHTML;
  //alert(getDocument(source).body.textContent);
  //alert(getDocument(target));
  var textoActual = strip_tags(getDocument(source).body.innerHTML);
  //alert(textoActual);
  obtenerAccion(textoActual);
  
}


//Funcion para determinar el estilo seleccionado y determinar la acción a ejecutar
function executeCommand(element, command, event, text) {
  var iframe = document.getElementById(element);

  if (command.toLowerCase() == "negro") {
	command = "forecolor";
    text = "Black";
    if (text == null || text == "") return;
  }
 
  if (command.toLowerCase() == "rojo") {
	command = "forecolor";
    text = "Red";
    if (text == null || text == "") return;
  }
  
  if (command.toLowerCase() == "azul") {
	command = "forecolor";
    text = "Blue";
    if (text == null || text == "") return;
  }

  if (command.toLowerCase() == "verde") {
	command = "forecolor";
    text = "Green";
    if (text == null || text == "") return;
  }
  
  if (command.toLowerCase() == "chico") {
	command = "fontsize";
    text = 1;
    if (text == null || text == "") return;
  }

  if (command.toLowerCase() == "normal") {
	command = "fontsize";
    text = 3;
    if (text == null || text == "") return;
  }

  if (command.toLowerCase() == "grande") {
	command = "fontsize";
    text = 5;
    if (text == null || text == "") return;
  }

  iframe.contentWindow.focus();
  getDocument(iframe).execCommand(command, false, text);
  registrarBloque('Estilo', '', '');
  estiloActivado = true;
  //setTextareaContent(event, element);
}

function seleccionar(img, fondo) {
  img.style.backgroundColor = fondo;
  img.style.border = '1px solid #0A246A';
}

function desseleccionar(img) {
  img.style.backgroundColor = '#F0F0EE';
  img.style.border = '1px solid #F0F0EE';
}

function addImage(src, editor, command, coment) {
  return '<img src="WYSIWYG/images/actions/'+src+'" onmouseover="seleccionar(this, \'#B6BDD2\');" onmouseout="desseleccionar(this);" onmousedown="seleccionar(this, \'#8592B5\');" onclick="executeCommand(\''+editor+'\', \''+command+'\', event); desseleccionar(this);" style="border: 1px solid #F0F0EE; width; 2px; height: 20px; cursor: pointer;" alt="'+coment+'" title="'+coment+'">';
}


function getValidId(name) {
  var id;
  if (!name) name = "text";
  if (!document.getElementById(name))
    id = name;
  else
    for (var i=1; document.getElementById(id = name+i); i++);
  return id;
}

function addSeparator() {
  return '<img src="WYSIWYG/images/spacer.gif" style="width; 2px; height: 20px;" alt="" title="">';
}

function makeWysiwyg (element) {
  textarea = element;
  if (!element.id) element.id = getValidId(element.name);

  var edit = element.id+'_edit';
  //var style = getStyle(element);

  //Agregar cada uno de los botones que deseamos integrar en el editor.
  html = '\
    <div style="margin-top:32px; border: 0px; width:100%; margin-left:auto; margin-right:auto;">\
    <div style="border:0px; background-color: #F0F0EE; padding: 0px;">\
	'+addSeparator()+'\
    '+addImage("bold.png", edit, "bold", "Negrita")+'\
	'+addSeparator()+'\
    '+addImage("italica.png", edit, "italic", "Cursiva")+'\
	'+addSeparator()+'\
    '+addImage("subrayado.png", edit, "underline", "Subrayado")+'\
	'+addSeparator()+'\
    '+addImage("chica.png", edit, "chico", "Chico")+'\
	'+addSeparator()+'\
    '+addImage("normal.png", edit, "normal", "Normal")+'\
	'+addSeparator()+'\
    '+addImage("grande.png", edit, "grande", "Grande")+'\
	'+addSeparator()+'\
	'+addImage("normal.png", edit, "negro", "Negro")+'\
	'+addSeparator()+'\
	'+addImage("rojo.png", edit, "rojo", "Rojo")+'\
	'+addSeparator()+'\
	'+addImage("azul.png", edit, "azul", "Azul")+'\
	'+addSeparator()+'\
	'+addImage("verde.png", edit, "verde", "Verde")+'\
	'+addSeparator()+'\
    </div>\
    <span id="'+edit+'">IFRAME</span>\
    </div>\
    ';

  if (isIE)
    element.insertAdjacentHTML("beforeBegin", html);
  else {
    var rng = element.ownerDocument.createRange();
    rng.setStartBefore(element);
    element.parentNode.insertBefore(rng.createContextualFragment(html), element);
  }

  element.style.display = 'none';
  element.startContent = element.value;

  var span = document.getElementById(edit);
  var iframe = document.createElement("iframe");
  iframe.id = edit;
  iframe.border = iframe.frameBorder = iframe.marginWidth = iframe.marginHeight = iframe.leftMargin = iframe.topMargin = "0";
  iframe.style.width = "100%";
  iframe.style.height = "300px";

  if (isIE) {
    iframe.src = "WYSIWYG/blank.html";
    span.outerHTML = iframe.outerHTML;
    getDocument(iframe).bgColor = "none";
  } else {
    span.parentNode.replaceChild(iframe, span);
    var doc = getDocument(iframe);
    doc.designMode = "on";
    doc.open();
    doc.write('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'
             +'<html>'
             +'<head>'
             +'<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">'
             +'</head>'
             +'<body style="padding: 2px; margin: 0; spacing: 0; word-wrap: break-word;">'
             +element.value
             +'</body>'
             +'</html>');
    doc.close();
    iframe.style.backgroundColor = "none";
  }

  var doc = getDocument(iframe);
  doc.editor = edit;
  addEvent(doc, "keydown", setTextareaContent);
  
  if (element.form)
    addEvent(element.form, "reset", resetForm);
}

function init() {
  if (!isIE && !isGECKO) return;
  var element = document.getElementById('areaTexto');
  //for (var i=0; i<elements.length; i++)
  //  if (wantToMake(elements[i].id))
  makeWysiwyg(element);
}

function getEventSource(event) {
  return isIE ? event.srcElement : event.target;
}

//addEvent(window, "load", init);
